<?php

namespace Drupal\user_revision_diff\Routing;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\RouteCollection;

/**
 * Listens to the dynamic route events.
 */
class RouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  public function alterRoutes(RouteCollection $collection) {
    // Replace the content from entity.user.version_history route with content
    // generated by revisionOverview method from UserRevisionController class.
    $route = $collection->get('entity.user.version_history');
    if ($route) {
      $route->addDefaults(
        array(
          '_controller' => '\Drupal\user_revision_diff\Controller\UserRevisionController::revisionOverview',
        )
      );
    }
  }

}
